kconfig: rename silentoldconfig to syncconfig
[linux-block.git] / scripts / kconfig / Makefile
CommitLineData
b2441318 1# SPDX-License-Identifier: GPL-2.0
1da177e4
LT
2# ===========================================================================
3# Kernel configuration targets
4# These targets are used from top-level makefile
5
911a91c3 6PHONY += xconfig gconfig menuconfig config syncconfig update-po-config \
281c9dad 7 localmodconfig localyesconfig
1da177e4 8
61bee204
AV
9ifdef KBUILD_KCONFIG
10Kconfig := $(KBUILD_KCONFIG)
11else
838a2e55 12Kconfig := Kconfig
61bee204 13endif
e703f75d 14
0a1f00a1
MM
15ifeq ($(quiet),silent_)
16silent := -s
17endif
18
c2838e6e
YM
19# We need this, in case the user has it in its environment
20unexport CONFIG_
21
1da177e4 22xconfig: $(obj)/qconf
0a1f00a1 23 $< $(silent) $(Kconfig)
1da177e4
LT
24
25gconfig: $(obj)/gconf
0a1f00a1 26 $< $(silent) $(Kconfig)
1da177e4
LT
27
28menuconfig: $(obj)/mconf
0a1f00a1 29 $< $(silent) $(Kconfig)
1da177e4
LT
30
31config: $(obj)/conf
0a1f00a1 32 $< $(silent) --oldaskconfig $(Kconfig)
1da177e4 33
692d97c3 34nconfig: $(obj)/nconf
0a1f00a1 35 $< $(silent) $(Kconfig)
692d97c3 36
cedd55d4
MH
37# This has become an internal implementation detail and is now deprecated
38# for external use.
911a91c3 39syncconfig: $(obj)/conf
9815594a 40 $(Q)mkdir -p include/config include/generated
d3fc425e
NP
41 $(Q)test -e include/generated/autoksyms.h || \
42 touch include/generated/autoksyms.h
0a1f00a1 43 $< $(silent) --$@ $(Kconfig)
1da177e4 44
50bce3e8 45localyesconfig localmodconfig: $(obj)/streamline_config.pl $(obj)/conf
9815594a 46 $(Q)mkdir -p include/config include/generated
22d550ae 47 $(Q)perl $< --$@ $(srctree) $(Kconfig) > .tmp.config
7a996d3a 48 $(Q)if [ -f .config ]; then \
4062f1a4
SR
49 cmp -s .tmp.config .config || \
50 (mv -f .config .config.old.1; \
51 mv -f .tmp.config .config; \
81d2bc22 52 $(obj)/conf $(silent) --oldconfig $(Kconfig); \
4062f1a4
SR
53 mv -f .config.old.1 .config.old) \
54 else \
55 mv -f .tmp.config .config; \
81d2bc22 56 $(obj)/conf $(silent) --oldconfig $(Kconfig); \
a7c02602 57 fi
03fa25da
SR
58 $(Q)rm -f .tmp.config
59
1020026f 60# Create new linux.pot file
b70e325c 61# Adjust charset to UTF-8 in .po file to accept UTF-8 in Kconfig files
46d26319 62update-po-config: $(obj)/kxgettext $(obj)/gconf.glade.h
0a1f00a1 63 $(Q)$(kecho) " GEN config.pot"
a24a1b8e
PF
64 $(Q)xgettext --default-domain=linux \
65 --add-comments --keyword=_ --keyword=N_ \
66 --from-code=UTF-8 \
67 --files-from=$(srctree)/scripts/kconfig/POTFILES.in \
68 --directory=$(srctree) --directory=$(objtree) \
b70e325c
SR
69 --output $(obj)/config.pot
70 $(Q)sed -i s/CHARSET/UTF-8/ $(obj)/config.pot
fa0ad657
PB
71 $(Q)(for i in `ls $(srctree)/arch/*/Kconfig \
72 $(srctree)/arch/*/um/Kconfig`; \
1020026f 73 do \
0a1f00a1 74 $(kecho) " GEN $$i"; \
4217516e 75 $(obj)/kxgettext $$i \
1020026f
EG
76 >> $(obj)/config.pot; \
77 done )
0a1f00a1 78 $(Q)$(kecho) " GEN linux.pot"
1020026f 79 $(Q)msguniq --sort-by-file --to-code=UTF-8 $(obj)/config.pot \
b70e325c 80 --output $(obj)/linux.pot
b70e325c 81 $(Q)rm -f $(obj)/config.pot
3b9fa093 82
1cba0c30
MM
83# These targets map 1:1 to the commandline options of 'conf'
84simple-targets := oldconfig allnoconfig allyesconfig allmodconfig \
85 alldefconfig randconfig listnewconfig olddefconfig
86PHONY += $(simple-targets)
1da177e4 87
1cba0c30 88$(simple-targets): $(obj)/conf
0a1f00a1 89 $< $(silent) --$@ $(Kconfig)
1da177e4 90
911a91c3 91PHONY += oldnoconfig silentoldconfig savedefconfig defconfig
1da177e4 92
fb16d891 93# oldnoconfig is an alias of olddefconfig, because people already are dependent
39c3f1ba 94# on its behavior (sets new symbols to their default value but not 'n') with the
fb16d891 95# counter-intuitive name.
1cba0c30 96oldnoconfig: olddefconfig
312ee687
MY
97 @echo " WARNING: \"oldnoconfig\" target will be removed after Linux 4.19"
98 @echo " Please use \"olddefconfig\" instead, which is an alias."
fb16d891 99
911a91c3
MY
100# We do not expect manual invokcation of "silentoldcofig" (or "syncconfig").
101silentoldconfig: syncconfig
102 @echo " WARNING: \"silentoldconfig\" has been renamed to \"syncconfig\""
103 @echo " and is now an internal implementation detail."
104 @echo " What you want is probably \"oldconfig\"."
105 @echo " \"silentoldconfig\" will be removed after Linux 4.19"
106
7cf3d73b 107savedefconfig: $(obj)/conf
0a1f00a1 108 $< $(silent) --$@=defconfig $(Kconfig)
7cf3d73b 109
1da177e4
LT
110defconfig: $(obj)/conf
111ifeq ($(KBUILD_DEFCONFIG),)
0a1f00a1 112 $< $(silent) --defconfig $(Kconfig)
42f9d3c6
JB
113else
114ifneq ($(wildcard $(srctree)/arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG)),)
0a1f00a1
MM
115 @$(kecho) "*** Default configuration is based on '$(KBUILD_DEFCONFIG)'"
116 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$(KBUILD_DEFCONFIG) $(Kconfig)
d2036f30
ME
117else
118 @$(kecho) "*** Default configuration is based on target '$(KBUILD_DEFCONFIG)'"
119 $(Q)$(MAKE) -f $(srctree)/Makefile $(KBUILD_DEFCONFIG)
1da177e4 120endif
42f9d3c6 121endif
1da177e4
LT
122
123%_defconfig: $(obj)/conf
0a1f00a1 124 $(Q)$< $(silent) --defconfig=arch/$(SRCARCH)/configs/$@ $(Kconfig)
1da177e4 125
63a91033 126configfiles=$(wildcard $(srctree)/kernel/configs/$@ $(srctree)/arch/$(SRCARCH)/configs/$@)
3aaefce1 127
63a91033
MY
128%.config: $(obj)/conf
129 $(if $(call configfiles),, $(error No configuration exists for this target on this architecture))
130 $(Q)$(CONFIG_SHELL) $(srctree)/scripts/kconfig/merge_config.sh -m .config $(configfiles)
131 +$(Q)yes "" | $(MAKE) -f $(srctree)/Makefile oldconfig
3aaefce1
JT
132
133PHONY += kvmconfig
63a91033
MY
134kvmconfig: kvm_guest.config
135 @:
3aaefce1 136
6c668505
LR
137PHONY += xenconfig
138xenconfig: xen.config
139 @:
140
0da1d4a0 141PHONY += tinyconfig
63a91033
MY
142tinyconfig:
143 $(Q)$(MAKE) -f $(srctree)/Makefile allnoconfig tiny.config
0da1d4a0 144
1da177e4
LT
145# Help text used by make help
146help:
147 @echo ' config - Update current config utilising a line-oriented program'
fa75a727
GU
148 @echo ' nconfig - Update current config utilising a ncurses menu based'
149 @echo ' program'
1da177e4 150 @echo ' menuconfig - Update current config utilising a menu based program'
092373c2 151 @echo ' xconfig - Update current config utilising a Qt based front-end'
39c3f1ba 152 @echo ' gconfig - Update current config utilising a GTK+ based front-end'
1da177e4 153 @echo ' oldconfig - Update current config utilising a provided .config as base'
03fa25da 154 @echo ' localmodconfig - Update current config disabling modules not loaded'
281c9dad 155 @echo ' localyesconfig - Update current config converting local mods to core'
0748cb3e 156 @echo ' defconfig - New config with default from ARCH supplied defconfig'
7cf3d73b 157 @echo ' savedefconfig - Save current config as ./defconfig (minimal config)'
e11f0496 158 @echo ' allnoconfig - New config where all options are answered with no'
0748cb3e
SR
159 @echo ' allyesconfig - New config where all options are accepted with yes'
160 @echo ' allmodconfig - New config selecting modules when possible'
161 @echo ' alldefconfig - New config with all symbols set to default'
162 @echo ' randconfig - New config with random answer to all options'
861b4ea4 163 @echo ' listnewconfig - List new options'
cedd55d4
MH
164 @echo ' olddefconfig - Same as oldconfig but sets new symbols to their'
165 @echo ' default value without prompting'
9bcd776d 166 @echo ' kvmconfig - Enable additional options for kvm guest kernel support'
6c668505 167 @echo ' xenconfig - Enable additional options for xen dom0 and guest kernel support'
0da1d4a0 168 @echo ' tinyconfig - Configure the tiniest possible kernel'
1da177e4 169
2982de69
SR
170# lxdialog stuff
171check-lxdialog := $(srctree)/$(src)/lxdialog/check-lxdialog.sh
172
e9e40e14 173# Use recursively expanded variables so we do not call gcc unless
2982de69 174# we really need to do so. (Do not call gcc as part of make mrproper)
9ba95682
AL
175HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(check-lxdialog) -ccflags) \
176 -DLOCALE
2982de69 177
1da177e4
LT
178# ===========================================================================
179# Shared Makefile for the various kconfig executables:
180# conf: Used for defconfig, oldconfig and related targets
692d97c3 181# nconf: Used for the nconfig target.
182# Utilizes ncurses
6f26e5e4 183# mconf: Used for the menuconfig target
1da177e4
LT
184# Utilizes the lxdialog package
185# qconf: Used for the xconfig target
092373c2 186# Based on Qt which needs to be installed to compile it
1da177e4 187# gconf: Used for the gconfig target
39c3f1ba 188# Based on GTK+ which needs to be installed to compile it
1da177e4
LT
189# object files used by all kconfig flavours
190
2982de69
SR
191lxdialog := lxdialog/checklist.o lxdialog/util.o lxdialog/inputbox.o
192lxdialog += lxdialog/textbox.o lxdialog/yesno.o lxdialog/menubox.o
193
1da177e4 194conf-objs := conf.o zconf.tab.o
692d97c3 195mconf-objs := mconf.o zconf.tab.o $(lxdialog)
196nconf-objs := nconf.o zconf.tab.o nconf.gui.o
3b9fa093 197kxgettext-objs := kxgettext.o zconf.tab.o
f1943049 198qconf-cxxobjs := qconf.o
5a6f8d2b
AL
199qconf-objs := zconf.tab.o
200gconf-objs := gconf.o zconf.tab.o
1da177e4 201
022af62d 202hostprogs-y := conf nconf mconf kxgettext qconf gconf
1da177e4 203
29c83306 204targets += zconf.tab.c zconf.lex.c
5a6f8d2b 205clean-files := qconf.moc .tmp_qtcheck .tmp_gtkcheck
bb3290d9 206clean-files += zconf.tab.c zconf.lex.c gconf.glade.h
1020026f 207clean-files += config.pot linux.pot
1da177e4 208
6e588f6d
SR
209# Check that we have the required ncurses stuff installed for lxdialog (menuconfig)
210PHONY += $(obj)/dochecklxdialog
ff85a1a8 211$(addprefix $(obj)/, mconf.o $(lxdialog)): $(obj)/dochecklxdialog
6e588f6d 212$(obj)/dochecklxdialog:
7080e47b 213 $(Q)$(CONFIG_SHELL) $(check-lxdialog) -check $(HOSTCC) $(HOST_EXTRACFLAGS) $(HOSTLOADLIBES_mconf)
6e588f6d
SR
214
215always := dochecklxdialog
216
aa1e5ef5
SR
217# Add environment specific flags
218HOST_EXTRACFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCC) $(HOSTCFLAGS))
d0fd0428 219HOST_EXTRACXXFLAGS += $(shell $(CONFIG_SHELL) $(srctree)/$(src)/check.sh $(HOSTCXX) $(HOSTCXXFLAGS))
70a6a0cb 220
1da177e4 221# generated files seem to need this to find local include files
2f76b358 222HOSTCFLAGS_zconf.lex.o := -I$(src)
1da177e4
LT
223HOSTCFLAGS_zconf.tab.o := -I$(src)
224
5a6f8d2b
AL
225HOSTLOADLIBES_qconf = $(KC_QT_LIBS)
226HOSTCXXFLAGS_qconf.o = $(KC_QT_CFLAGS)
1da177e4 227
5a6f8d2b 228HOSTLOADLIBES_gconf = `pkg-config --libs gtk+-2.0 gmodule-2.0 libglade-2.0`
37193147 229HOSTCFLAGS_gconf.o = `pkg-config --cflags gtk+-2.0 gmodule-2.0 libglade-2.0` \
1ea3ad4e 230 -Wno-missing-prototypes
1da177e4 231
7080e47b
AL
232HOSTLOADLIBES_mconf = $(shell $(CONFIG_SHELL) $(check-lxdialog) -ldflags $(HOSTCC))
233
544e7e54 234HOSTLOADLIBES_nconf = $(shell \
7285996a
BN
235 pkg-config --libs menuw panelw ncursesw 2>/dev/null \
236 || pkg-config --libs menu panel ncurses 2>/dev/null \
544e7e54 237 || echo "-lmenu -lpanel -lncurses" )
1da177e4
LT
238$(obj)/qconf.o: $(obj)/.tmp_qtcheck
239
022af62d 240ifeq ($(MAKECMDGOALS),xconfig)
b3a5225f 241$(obj)/.tmp_qtcheck: $(src)/Makefile
1da177e4
LT
242-include $(obj)/.tmp_qtcheck
243
092373c2 244# Qt needs some extra effort...
1da177e4 245$(obj)/.tmp_qtcheck:
d1b0dc90 246 @set -e; $(kecho) " CHECK qt"; \
588446a8
TM
247 if pkg-config --exists Qt5Core; then \
248 cflags="-std=c++11 -fPIC `pkg-config --cflags Qt5Core Qt5Gui Qt5Widgets`"; \
249 libs=`pkg-config --libs Qt5Core Qt5Gui Qt5Widgets`; \
250 moc=`pkg-config --variable=host_bins Qt5Core`/moc; \
251 elif pkg-config --exists QtCore; then \
252 cflags=`pkg-config --cflags QtCore QtGui`; \
253 libs=`pkg-config --libs QtCore QtGui`; \
254 moc=`pkg-config --variable=moc_location QtCore`; \
ab919c06 255 else \
d1b0dc90 256 echo >&2 "*"; \
588446a8
TM
257 echo >&2 "* Could not find Qt via pkg-config."; \
258 echo >&2 "* Please install either Qt 4.8 or 5.x. and make sure it's in PKG_CONFIG_PATH"; \
d1b0dc90
TM
259 echo >&2 "*"; \
260 exit 1; \
b3a5225f
RZ
261 fi; \
262 echo "KC_QT_CFLAGS=$$cflags" > $@; \
263 echo "KC_QT_LIBS=$$libs" >> $@; \
264 echo "KC_QT_MOC=$$moc" >> $@
1da177e4
LT
265endif
266
267$(obj)/gconf.o: $(obj)/.tmp_gtkcheck
268
022af62d 269ifeq ($(MAKECMDGOALS),gconfig)
1da177e4
LT
270-include $(obj)/.tmp_gtkcheck
271
39c3f1ba 272# GTK+ needs some extra effort, too...
1da177e4 273$(obj)/.tmp_gtkcheck:
37193147
AB
274 @if `pkg-config --exists gtk+-2.0 gmodule-2.0 libglade-2.0`; then \
275 if `pkg-config --atleast-version=2.0.0 gtk+-2.0`; then \
1da177e4
LT
276 touch $@; \
277 else \
5b580fa6
MM
278 echo >&2 "*"; \
279 echo >&2 "* GTK+ is present but version >= 2.0.0 is required."; \
280 echo >&2 "*"; \
1da177e4
LT
281 false; \
282 fi \
283 else \
5b580fa6
MM
284 echo >&2 "*"; \
285 echo >&2 "* Unable to find the GTK+ installation. Please make sure that"; \
286 echo >&2 "* the GTK+ 2.0 development package is correctly installed..."; \
287 echo >&2 "* You need gtk+-2.0, glib-2.0 and libglade-2.0."; \
288 echo >&2 "*"; \
1da177e4
LT
289 false; \
290 fi
291endif
292
bb3290d9 293$(obj)/zconf.tab.o: $(obj)/zconf.lex.c
1da177e4 294
5a6f8d2b 295$(obj)/qconf.o: $(obj)/qconf.moc
1da177e4 296
ebca026a
YS
297quiet_cmd_moc = MOC $@
298 cmd_moc = $(KC_QT_MOC) -i $< -o $@
299
300$(obj)/%.moc: $(src)/%.h $(obj)/.tmp_qtcheck
301 $(call cmd,moc)
1da177e4 302
39c3f1ba 303# Extract gconf menu items for i18n support
46d26319 304$(obj)/gconf.glade.h: $(obj)/gconf.glade
2d80eb0f 305 $(Q)intltool-extract --type=gettext/glade --srcdir=$(srctree) \
a24a1b8e 306 $(obj)/gconf.glade